/* im2avi_t.h copyright 2001, 2002 by Charl P. Botha http://cpbotha.net/
 *
 * $Id: im2avi_t.h,v 1.3 2001/12/28 17:20:52 cpbotha Exp $
 *
 * im2avi: frontend to avifile and Magick++ for making AVIs from images.
 * Copyright (C) 2001,2002  Charl P. Botha
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#ifndef _im2avi_h
#define _im2avi_h

class Fl_Button;
class Fl_File_Chooser;
class Fl_Value_Input;
class main_window_t;

#include <default.h> // from avifile, required for fourcc_t;
#include <vector>

class im2avi_t
{
protected:
   main_window_t* main_window;
   Fl_File_Chooser* file_chooser;
   vector<fourcc_t> avi_codec_fourccs;
   int image_width;
   int image_height;
   float image_aspect_ratio;
public:
   im2avi_t(int argc, char* argv[]);
   ~im2avi_t();
   int run(void);
   void mw_button_cb(Fl_Button* w, void* user_data);
   void mw_input_cb(Fl_Value_Input* w, void* user_data);
   void add_images_fs(void);
   void remove_images(void);
   void load_images_list(void);
   void save_images_list(void);
   void move_selection(int to);
   void move_selection_diff(int diff);
   void move_selection_to_bottom(void);
   void update_image_width(bool ignore_aspect = false);
   void update_image_height(bool ignore_aspect = false);
   void browse_avi_filename(void);
   void auto_wxh(void);
   void make_avi(void);
   void update_progress_ui(float percentage);
};

#endif
